package com.buy507.mall.model;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class UmsMemberOrderQueueExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public UmsMemberOrderQueueExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andMemberIdIsNull() {
            addCriterion("member_id is null");
            return (Criteria) this;
        }

        public Criteria andMemberIdIsNotNull() {
            addCriterion("member_id is not null");
            return (Criteria) this;
        }

        public Criteria andMemberIdEqualTo(Long value) {
            addCriterion("member_id =", value, "memberId");
            return (Criteria) this;
        }

        public Criteria andMemberIdNotEqualTo(Long value) {
            addCriterion("member_id <>", value, "memberId");
            return (Criteria) this;
        }

        public Criteria andMemberIdGreaterThan(Long value) {
            addCriterion("member_id >", value, "memberId");
            return (Criteria) this;
        }

        public Criteria andMemberIdGreaterThanOrEqualTo(Long value) {
            addCriterion("member_id >=", value, "memberId");
            return (Criteria) this;
        }

        public Criteria andMemberIdLessThan(Long value) {
            addCriterion("member_id <", value, "memberId");
            return (Criteria) this;
        }

        public Criteria andMemberIdLessThanOrEqualTo(Long value) {
            addCriterion("member_id <=", value, "memberId");
            return (Criteria) this;
        }

        public Criteria andMemberIdIn(List<Long> values) {
            addCriterion("member_id in", values, "memberId");
            return (Criteria) this;
        }

        public Criteria andMemberIdNotIn(List<Long> values) {
            addCriterion("member_id not in", values, "memberId");
            return (Criteria) this;
        }

        public Criteria andMemberIdBetween(Long value1, Long value2) {
            addCriterion("member_id between", value1, value2, "memberId");
            return (Criteria) this;
        }

        public Criteria andMemberIdNotBetween(Long value1, Long value2) {
            addCriterion("member_id not between", value1, value2, "memberId");
            return (Criteria) this;
        }

        public Criteria andOrderIdIsNull() {
            addCriterion("order_id is null");
            return (Criteria) this;
        }

        public Criteria andOrderIdIsNotNull() {
            addCriterion("order_id is not null");
            return (Criteria) this;
        }

        public Criteria andOrderIdEqualTo(Long value) {
            addCriterion("order_id =", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdNotEqualTo(Long value) {
            addCriterion("order_id <>", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdGreaterThan(Long value) {
            addCriterion("order_id >", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdGreaterThanOrEqualTo(Long value) {
            addCriterion("order_id >=", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdLessThan(Long value) {
            addCriterion("order_id <", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdLessThanOrEqualTo(Long value) {
            addCriterion("order_id <=", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdIn(List<Long> values) {
            addCriterion("order_id in", values, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdNotIn(List<Long> values) {
            addCriterion("order_id not in", values, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdBetween(Long value1, Long value2) {
            addCriterion("order_id between", value1, value2, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdNotBetween(Long value1, Long value2) {
            addCriterion("order_id not between", value1, value2, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderAmountIsNull() {
            addCriterion("order_amount is null");
            return (Criteria) this;
        }

        public Criteria andOrderAmountIsNotNull() {
            addCriterion("order_amount is not null");
            return (Criteria) this;
        }

        public Criteria andOrderAmountEqualTo(BigDecimal value) {
            addCriterion("order_amount =", value, "orderAmount");
            return (Criteria) this;
        }

        public Criteria andOrderAmountNotEqualTo(BigDecimal value) {
            addCriterion("order_amount <>", value, "orderAmount");
            return (Criteria) this;
        }

        public Criteria andOrderAmountGreaterThan(BigDecimal value) {
            addCriterion("order_amount >", value, "orderAmount");
            return (Criteria) this;
        }

        public Criteria andOrderAmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("order_amount >=", value, "orderAmount");
            return (Criteria) this;
        }

        public Criteria andOrderAmountLessThan(BigDecimal value) {
            addCriterion("order_amount <", value, "orderAmount");
            return (Criteria) this;
        }

        public Criteria andOrderAmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("order_amount <=", value, "orderAmount");
            return (Criteria) this;
        }

        public Criteria andOrderAmountIn(List<BigDecimal> values) {
            addCriterion("order_amount in", values, "orderAmount");
            return (Criteria) this;
        }

        public Criteria andOrderAmountNotIn(List<BigDecimal> values) {
            addCriterion("order_amount not in", values, "orderAmount");
            return (Criteria) this;
        }

        public Criteria andOrderAmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("order_amount between", value1, value2, "orderAmount");
            return (Criteria) this;
        }

        public Criteria andOrderAmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("order_amount not between", value1, value2, "orderAmount");
            return (Criteria) this;
        }

        public Criteria andQueueIndexIsNull() {
            addCriterion("queue_index is null");
            return (Criteria) this;
        }

        public Criteria andQueueIndexIsNotNull() {
            addCriterion("queue_index is not null");
            return (Criteria) this;
        }

        public Criteria andQueueIndexEqualTo(Long value) {
            addCriterion("queue_index =", value, "queueIndex");
            return (Criteria) this;
        }

        public Criteria andQueueIndexNotEqualTo(Long value) {
            addCriterion("queue_index <>", value, "queueIndex");
            return (Criteria) this;
        }

        public Criteria andQueueIndexGreaterThan(Long value) {
            addCriterion("queue_index >", value, "queueIndex");
            return (Criteria) this;
        }

        public Criteria andQueueIndexGreaterThanOrEqualTo(Long value) {
            addCriterion("queue_index >=", value, "queueIndex");
            return (Criteria) this;
        }

        public Criteria andQueueIndexLessThan(Long value) {
            addCriterion("queue_index <", value, "queueIndex");
            return (Criteria) this;
        }

        public Criteria andQueueIndexLessThanOrEqualTo(Long value) {
            addCriterion("queue_index <=", value, "queueIndex");
            return (Criteria) this;
        }

        public Criteria andQueueIndexIn(List<Long> values) {
            addCriterion("queue_index in", values, "queueIndex");
            return (Criteria) this;
        }

        public Criteria andQueueIndexNotIn(List<Long> values) {
            addCriterion("queue_index not in", values, "queueIndex");
            return (Criteria) this;
        }

        public Criteria andQueueIndexBetween(Long value1, Long value2) {
            addCriterion("queue_index between", value1, value2, "queueIndex");
            return (Criteria) this;
        }

        public Criteria andQueueIndexNotBetween(Long value1, Long value2) {
            addCriterion("queue_index not between", value1, value2, "queueIndex");
            return (Criteria) this;
        }

        public Criteria andQuitQueueMarkIsNull() {
            addCriterion("quit_queue_mark is null");
            return (Criteria) this;
        }

        public Criteria andQuitQueueMarkIsNotNull() {
            addCriterion("quit_queue_mark is not null");
            return (Criteria) this;
        }

        public Criteria andQuitQueueMarkEqualTo(Integer value) {
            addCriterion("quit_queue_mark =", value, "quitQueueMark");
            return (Criteria) this;
        }

        public Criteria andQuitQueueMarkNotEqualTo(Integer value) {
            addCriterion("quit_queue_mark <>", value, "quitQueueMark");
            return (Criteria) this;
        }

        public Criteria andQuitQueueMarkGreaterThan(Integer value) {
            addCriterion("quit_queue_mark >", value, "quitQueueMark");
            return (Criteria) this;
        }

        public Criteria andQuitQueueMarkGreaterThanOrEqualTo(Integer value) {
            addCriterion("quit_queue_mark >=", value, "quitQueueMark");
            return (Criteria) this;
        }

        public Criteria andQuitQueueMarkLessThan(Integer value) {
            addCriterion("quit_queue_mark <", value, "quitQueueMark");
            return (Criteria) this;
        }

        public Criteria andQuitQueueMarkLessThanOrEqualTo(Integer value) {
            addCriterion("quit_queue_mark <=", value, "quitQueueMark");
            return (Criteria) this;
        }

        public Criteria andQuitQueueMarkIn(List<Integer> values) {
            addCriterion("quit_queue_mark in", values, "quitQueueMark");
            return (Criteria) this;
        }

        public Criteria andQuitQueueMarkNotIn(List<Integer> values) {
            addCriterion("quit_queue_mark not in", values, "quitQueueMark");
            return (Criteria) this;
        }

        public Criteria andQuitQueueMarkBetween(Integer value1, Integer value2) {
            addCriterion("quit_queue_mark between", value1, value2, "quitQueueMark");
            return (Criteria) this;
        }

        public Criteria andQuitQueueMarkNotBetween(Integer value1, Integer value2) {
            addCriterion("quit_queue_mark not between", value1, value2, "quitQueueMark");
            return (Criteria) this;
        }

        public Criteria andQueueTypeIsNull() {
            addCriterion("queue_type is null");
            return (Criteria) this;
        }

        public Criteria andQueueTypeIsNotNull() {
            addCriterion("queue_type is not null");
            return (Criteria) this;
        }

        public Criteria andQueueTypeEqualTo(Integer value) {
            addCriterion("queue_type =", value, "queueType");
            return (Criteria) this;
        }

        public Criteria andQueueTypeNotEqualTo(Integer value) {
            addCriterion("queue_type <>", value, "queueType");
            return (Criteria) this;
        }

        public Criteria andQueueTypeGreaterThan(Integer value) {
            addCriterion("queue_type >", value, "queueType");
            return (Criteria) this;
        }

        public Criteria andQueueTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("queue_type >=", value, "queueType");
            return (Criteria) this;
        }

        public Criteria andQueueTypeLessThan(Integer value) {
            addCriterion("queue_type <", value, "queueType");
            return (Criteria) this;
        }

        public Criteria andQueueTypeLessThanOrEqualTo(Integer value) {
            addCriterion("queue_type <=", value, "queueType");
            return (Criteria) this;
        }

        public Criteria andQueueTypeIn(List<Integer> values) {
            addCriterion("queue_type in", values, "queueType");
            return (Criteria) this;
        }

        public Criteria andQueueTypeNotIn(List<Integer> values) {
            addCriterion("queue_type not in", values, "queueType");
            return (Criteria) this;
        }

        public Criteria andQueueTypeBetween(Integer value1, Integer value2) {
            addCriterion("queue_type between", value1, value2, "queueType");
            return (Criteria) this;
        }

        public Criteria andQueueTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("queue_type not between", value1, value2, "queueType");
            return (Criteria) this;
        }

        public Criteria andAccelerateSwitchIsNull() {
            addCriterion("accelerate_switch is null");
            return (Criteria) this;
        }

        public Criteria andAccelerateSwitchIsNotNull() {
            addCriterion("accelerate_switch is not null");
            return (Criteria) this;
        }

        public Criteria andAccelerateSwitchEqualTo(Integer value) {
            addCriterion("accelerate_switch =", value, "accelerateSwitch");
            return (Criteria) this;
        }

        public Criteria andAccelerateSwitchNotEqualTo(Integer value) {
            addCriterion("accelerate_switch <>", value, "accelerateSwitch");
            return (Criteria) this;
        }

        public Criteria andAccelerateSwitchGreaterThan(Integer value) {
            addCriterion("accelerate_switch >", value, "accelerateSwitch");
            return (Criteria) this;
        }

        public Criteria andAccelerateSwitchGreaterThanOrEqualTo(Integer value) {
            addCriterion("accelerate_switch >=", value, "accelerateSwitch");
            return (Criteria) this;
        }

        public Criteria andAccelerateSwitchLessThan(Integer value) {
            addCriterion("accelerate_switch <", value, "accelerateSwitch");
            return (Criteria) this;
        }

        public Criteria andAccelerateSwitchLessThanOrEqualTo(Integer value) {
            addCriterion("accelerate_switch <=", value, "accelerateSwitch");
            return (Criteria) this;
        }

        public Criteria andAccelerateSwitchIn(List<Integer> values) {
            addCriterion("accelerate_switch in", values, "accelerateSwitch");
            return (Criteria) this;
        }

        public Criteria andAccelerateSwitchNotIn(List<Integer> values) {
            addCriterion("accelerate_switch not in", values, "accelerateSwitch");
            return (Criteria) this;
        }

        public Criteria andAccelerateSwitchBetween(Integer value1, Integer value2) {
            addCriterion("accelerate_switch between", value1, value2, "accelerateSwitch");
            return (Criteria) this;
        }

        public Criteria andAccelerateSwitchNotBetween(Integer value1, Integer value2) {
            addCriterion("accelerate_switch not between", value1, value2, "accelerateSwitch");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }
            public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
            }
            public Criteria andAccelerateOrderIdEqualTo(long highOrderId ) {
                addCriterion("accelerate_order_id =", highOrderId, "accelerateOrderId");
                return (Criteria) this;
            }

    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}